## libav 10.1

=== Makefile ===
include config.mak

vpath %.c    $(SRC_PATH)
vpath %.h    $(SRC_PATH)
vpath %.S    $(SRC_PATH)
vpath %.asm  $(SRC_PATH)
vpath %.v    $(SRC_PATH)
vpath %.texi $(SRC_PATH)

ifndef V
Q      = @
ECHO   = printf "$(1)\t%s\n" $(2)
BRIEF  = CC HOSTCC HOSTLD AS YASM AR LD
SILENT = DEPCC DEPHOSTCC DEPAS DEPYASM RANLIB RM STRIP
MSG    = $@
M      = @$(call ECHO,$(TAG),$@);
$(foreach VAR,$(BRIEF), \
    $(eval override $(VAR) = @$$(call ECHO,$(VAR),$$(MSG)); $($(VAR))))
$(foreach VAR,$(SILENT),$(eval override $(VAR) = @$($(VAR))))
$(eval INSTALL = @$(call ECHO,INSTALL,$$(^:$(SRC_PATH)/%=%)); $(INSTALL))
endif

ALLFFLIBS = avcodec avdevice avfilter avformat avresample avutil swscale

IFLAGS     := -I. -I$(SRC_PATH)
CPPFLAGS   := $(IFLAGS) $(CPPFLAGS)
CFLAGS     += $(ECFLAGS)
CCFLAGS     = $(CPPFLAGS) $(CFLAGS)
ASFLAGS    := $(CPPFLAGS) $(ASFLAGS)
YASMFLAGS  += $(IFLAGS:%=%/) -Pconfig.asm
HOSTCCFLAGS = $(IFLAGS) $(HOSTCPPFLAGS) $(HOSTCFLAGS)
LDFLAGS    := $(ALLFFLIBS:%=$(LD_PATH)lib%) $(LDFLAGS)

define COMPILE
	$(call $(1)DEP,$(1))
	$($(1)) $($(1)FLAGS) $($(1)_DEPFLAGS) $($(1)_C) $($(1)_O) $<
endef

COMPILE_C = $(call COMPILE,CC)
COMPILE_S = $(call COMPILE,AS)
COMPILE_HOSTC = $(call COMPILE,HOSTCC)

%.o: %.c
	$(COMPILE_C)

%.o: %.S
	$(COMPILE_S)

%_host.o: %.c
	$(COMPILE_HOSTC)

%.i: %.c
	$(CC) $(CCFLAGS) $(CC_E) $<

%.h.c:
	$(Q)echo '#include "$*.h"' >$@

%.ver: %.v
	$(Q)sed 's/$$MAJOR/$($(basename $(@F))_VERSION_MAJOR)/' $^ > $@

%.c %.h: TAG = GEN

AVPROGS-$(CONFIG_AVCONV)   += avconv
AVPROGS-$(CONFIG_AVPLAY)   += avplay
AVPROGS-$(CONFIG_AVPROBE)  += avprobe
AVPROGS-$(CONFIG_AVSERVER) += avserver

AVPROGS    := $(AVPROGS-yes:%=%$(EXESUF))
PROGS      += $(AVPROGS)

AVBASENAMES = avconv avplay avprobe avserver
ALLAVPROGS  = $(AVBASENAMES:%=%$(EXESUF))

$(foreach prog,$(AVBASENAMES),$(eval OBJS-$(prog) += cmdutils.o))

OBJS-avconv                   += avconv_opt.o avconv_filter.o
OBJS-avconv-$(HAVE_VDPAU_X11) += avconv_vdpau.o

TESTTOOLS   = audiogen videogen rotozoom tiny_psnr base64
HOSTPROGS  := $(TESTTOOLS:%=tests/%) doc/print_options
TOOLS       = qt-faststart trasher
TOOLS-$(CONFIG_ZLIB) += cws2fws

FFLIBS-$(CONFIG_AVDEVICE) += avdevice
FFLIBS-$(CONFIG_AVFILTER) += avfilter
FFLIBS-$(CONFIG_AVFORMAT) += avformat
FFLIBS-$(CONFIG_AVRESAMPLE) += avresample
FFLIBS-$(CONFIG_AVCODEC)  += avcodec
FFLIBS-$(CONFIG_SWSCALE)  += swscale

FFLIBS := avutil

DATA_FILES := $(wildcard $(SRC_PATH)/presets/*.avpreset)

SKIPHEADERS = cmdutils_common_opts.h compat/w32pthreads.h

include $(SRC_PATH)/common.mak

FF_EXTRALIBS := $(FFEXTRALIBS)
FF_DEP_LIBS  := $(DEP_LIBS)

all: $(AVPROGS)

$(TOOLS): %$(EXESUF): %.o $(EXEOBJS)
	$(LD) $(LDFLAGS) $(LD_O) $^ $(ELIBS)

tools/cws2fws$(EXESUF): ELIBS = $(ZLIB)

config.h: .config
.config: $(wildcard $(FFLIBS:%=$(SRC_PATH)/lib%/all*.c))
	@-tput bold 2>/dev/null
	@-printf '\nWARNING: $(?F) newer than config.h, rerun configure\n\n'
	@-tput sgr0 2>/dev/null

SUBDIR_VARS := CLEANFILES EXAMPLES FFLIBS HOSTPROGS TESTPROGS TOOLS      \
               HEADERS ARCH_HEADERS BUILT_HEADERS SKIPHEADERS            \
               ARMV5TE-OBJS ARMV6-OBJS VFP-OBJS NEON-OBJS                \
               ALTIVEC-OBJS VIS-OBJS                                     \
               MMX-OBJS YASM-OBJS                                        \
               OBJS HOSTOBJS TESTOBJS

define RESET
$(1) :=
$(1)-yes :=
endef

define DOSUBDIR
$(foreach V,$(SUBDIR_VARS),$(eval $(call RESET,$(V))))
SUBDIR := $(1)/
include $(SRC_PATH)/$(1)/Makefile
-include $(SRC_PATH)/$(1)/$(ARCH)/Makefile
include $(SRC_PATH)/library.mak
endef

$(foreach D,$(FFLIBS),$(eval $(call DOSUBDIR,lib$(D))))

include $(SRC_PATH)/doc/Makefile

define DOPROG
OBJS-$(1) += $(1).o $(EXEOBJS) $(OBJS-$(1)-yes)
$(1)$(EXESUF): $$(OBJS-$(1))
$$(OBJS-$(1)): CFLAGS  += $(CFLAGS-$(1))
$(1)$(EXESUF): LDFLAGS += $(LDFLAGS-$(1))
$(1)$(EXESUF): FF_EXTRALIBS += $(LIBS-$(1))
-include $$(OBJS-$(1):.o=.d)
endef

$(foreach P,$(PROGS),$(eval $(call DOPROG,$(P:$(EXESUF)=))))

$(PROGS): %$(EXESUF): %.o $(FF_DEP_LIBS)
	$(LD) $(LDFLAGS) $(LD_O) $(OBJS-$*) $(FF_EXTRALIBS)

OBJDIRS += tools

-include $(wildcard tools/*.d)

VERSION_SH  = $(SRC_PATH)/version.sh
GIT_LOG     = $(SRC_PATH)/.git/logs/HEAD

.version: $(wildcard $(GIT_LOG)) $(VERSION_SH) config.mak
.version: M=@

version.h .version:
	$(M)$(VERSION_SH) $(SRC_PATH) version.h $(EXTRA_VERSION)
	$(Q)touch .version

# force version.sh to run whenever version might have changed
-include .version

ifdef AVPROGS
install: install-progs install-data
endif

install: install-libs install-headers

install-libs: install-libs-yes

install-progs-yes:
install-progs-$(CONFIG_SHARED): install-libs

install-progs: install-progs-yes $(AVPROGS)
	$(Q)mkdir -p "$(BINDIR)"
	$(INSTALL) -c -m 755 $(AVPROGS) "$(BINDIR)"

install-data: $(DATA_FILES)
	$(Q)mkdir -p "$(DATADIR)"
	$(INSTALL) -m 644 $(DATA_FILES) "$(DATADIR)"

uninstall: uninstall-libs uninstall-headers uninstall-progs uninstall-data

uninstall-progs:
	$(RM) $(addprefix "$(BINDIR)/", $(ALLAVPROGS))

uninstall-data:
	$(RM) -r "$(DATADIR)"

clean::
	$(RM) $(ALLAVPROGS)
	$(RM) $(CLEANSUFFIXES)
	$(RM) $(CLEANSUFFIXES:%=tools/%)
	$(RM) -rf coverage.info lcov

distclean::
	$(RM) $(DISTCLEANSUFFIXES)
	$(RM) config.* .config libavutil/avconfig.h .version version.h

config:
	$(SRC_PATH)/configure $(value LIBAV_CONFIGURATION)

check: all alltools checkheaders examples testprogs fate

include $(SRC_PATH)/tests/Makefile

$(sort $(OBJDIRS)):
	$(Q)mkdir -p $@

# Dummy rule to stop make trying to rebuild removed or renamed headers
%.h:
	@:

# Disable suffix rules.  Most of the builtin rules are suffix rules,
# so this saves some time on slow systems.
.SUFFIXES:

.PHONY: all all-yes alltools check *clean config examples install*
.PHONY: testprogs uninstall*

=== libavformat/Makefile ===
NAME = avformat
FFLIBS = avcodec avutil

HEADERS = avformat.h                                                    \
          avio.h                                                        \
          version.h                                                     \

OBJS = allformats.o         \
       avio.o               \
       aviobuf.o            \
       cutils.o             \
       format.o             \
       id3v1.o              \
       id3v2.o              \
       log2_tab.o           \
       metadata.o           \
       mux.o                \
       options.o            \
       os_support.o         \
       riff.o               \
       sdp.o                \
       seek.o               \
       url.o                \
       utils.o              \

OBJS-$(CONFIG_NETWORK)                   += network.o
OBJS-$(CONFIG_RIFFDEC)                   += riffdec.o
OBJS-$(CONFIG_RIFFENC)                   += riffenc.o
OBJS-$(CONFIG_RTPDEC)                    += rdt.o                       \
                                            rtp.o                       \
                                            rtpdec.o                    \
                                            rtpdec_amr.o                \
                                            rtpdec_asf.o                \
                                            rtpdec_g726.o               \
                                            rtpdec_h263.o               \
                                            rtpdec_h263_rfc2190.o       \
                                            rtpdec_h264.o               \
                                            rtpdec_ilbc.o               \
                                            rtpdec_jpeg.o               \
                                            rtpdec_latm.o               \
                                            rtpdec_mpeg12.o             \
                                            rtpdec_mpeg4.o              \
                                            rtpdec_mpegts.o             \
                                            rtpdec_qcelp.o              \
                                            rtpdec_qdm2.o               \
                                            rtpdec_qt.o                 \
                                            rtpdec_svq3.o               \
                                            rtpdec_vp8.o                \
                                            rtpdec_xiph.o               \
                                            srtp.o
OBJS-$(CONFIG_RTPENC_CHAIN)              += rtpenc_chain.o rtp.o

# muxers/demuxers
OBJS-$(CONFIG_A64_MUXER)                 += a64.o rawenc.o
OBJS-$(CONFIG_AAC_DEMUXER)               += aacdec.o rawdec.o
OBJS-$(CONFIG_AC3_DEMUXER)               += ac3dec.o rawdec.o
OBJS-$(CONFIG_AC3_MUXER)                 += rawenc.o
OBJS-$(CONFIG_ADX_DEMUXER)               += adxdec.o
OBJS-$(CONFIG_ADX_MUXER)                 += rawenc.o
OBJS-$(CONFIG_ADTS_MUXER)                += adtsenc.o
OBJS-$(CONFIG_AEA_DEMUXER)               += aea.o pcm.o
OBJS-$(CONFIG_AIFF_DEMUXER)              += aiffdec.o pcm.o
OBJS-$(CONFIG_AIFF_MUXER)                += aiffenc.o
OBJS-$(CONFIG_AMR_DEMUXER)               += amr.o
OBJS-$(CONFIG_AMR_MUXER)                 += amr.o
OBJS-$(CONFIG_ANM_DEMUXER)               += anm.o
OBJS-$(CONFIG_APC_DEMUXER)               += apc.o
OBJS-$(CONFIG_APE_DEMUXER)               += ape.o apetag.o img2.o
OBJS-$(CONFIG_ASF_DEMUXER)               += asfdec.o asf.o asfcrypt.o \
                                            avlanguage.o
OBJS-$(CONFIG_ASF_MUXER)                 += asfenc.o asf.o
OBJS-$(CONFIG_ASS_DEMUXER)               += assdec.o
OBJS-$(CONFIG_ASS_MUXER)                 += assenc.o
OBJS-$(CONFIG_AU_DEMUXER)                += au.o pcm.o
OBJS-$(CONFIG_AU_MUXER)                  += au.o rawenc.o
OBJS-$(CONFIG_AVI_DEMUXER)               += avidec.o
OBJS-$(CONFIG_AVI_MUXER)                 += avienc.o
OBJS-$(CONFIG_AVISYNTH)                  += avisynth.o
OBJS-$(CONFIG_AVM2_MUXER)                += swfenc.o swf.o
OBJS-$(CONFIG_AVS_DEMUXER)               += avs.o vocdec.o voc.o
OBJS-$(CONFIG_BETHSOFTVID_DEMUXER)       += bethsoftvid.o
OBJS-$(CONFIG_BFI_DEMUXER)               += bfi.o
OBJS-$(CONFIG_BINK_DEMUXER)              += bink.o
OBJS-$(CONFIG_BMV_DEMUXER)               += bmv.o
OBJS-$(CONFIG_C93_DEMUXER)               += c93.o vocdec.o voc.o
OBJS-$(CONFIG_CAF_DEMUXER)               += cafdec.o caf.o mov.o mov_chan.o \
                                            isom.o
OBJS-$(CONFIG_CAVSVIDEO_DEMUXER)         += cavsvideodec.o rawdec.o
OBJS-$(CONFIG_CAVSVIDEO_MUXER)           += rawenc.o
OBJS-$(CONFIG_CDG_DEMUXER)               += cdg.o
OBJS-$(CONFIG_CDXL_DEMUXER)              += cdxl.o
OBJS-$(CONFIG_CRC_MUXER)                 += crcenc.o
OBJS-$(CONFIG_DAUD_DEMUXER)              += daud.o
OBJS-$(CONFIG_DAUD_MUXER)                += daud.o
OBJS-$(CONFIG_DFA_DEMUXER)               += dfa.o
OBJS-$(CONFIG_DIRAC_DEMUXER)             += diracdec.o rawdec.o
OBJS-$(CONFIG_DIRAC_MUXER)               += rawenc.o
OBJS-$(CONFIG_DNXHD_DEMUXER)             += dnxhddec.o rawdec.o
OBJS-$(CONFIG_DNXHD_MUXER)               += rawenc.o
OBJS-$(CONFIG_DSICIN_DEMUXER)            += dsicin.o
OBJS-$(CONFIG_DTS_DEMUXER)               += dtsdec.o rawdec.o
OBJS-$(CONFIG_DTS_MUXER)                 += rawenc.o
OBJS-$(CONFIG_DV_DEMUXER)                += dv.o
OBJS-$(CONFIG_DV_MUXER)                  += dvenc.o
OBJS-$(CONFIG_DXA_DEMUXER)               += dxa.o
OBJS-$(CONFIG_EA_CDATA_DEMUXER)          += eacdata.o
OBJS-$(CONFIG_EA_DEMUXER)                += electronicarts.o
OBJS-$(CONFIG_EAC3_DEMUXER)              += ac3dec.o rawdec.o
OBJS-$(CONFIG_EAC3_MUXER)                += rawenc.o
OBJS-$(CONFIG_FFM_DEMUXER)               += ffmdec.o
OBJS-$(CONFIG_FFM_MUXER)                 += ffmenc.o
OBJS-$(CONFIG_FFMETADATA_DEMUXER)        += ffmetadec.o
OBJS-$(CONFIG_FFMETADATA_MUXER)          += ffmetaenc.o
OBJS-$(CONFIG_FILMSTRIP_DEMUXER)         += filmstripdec.o
OBJS-$(CONFIG_FILMSTRIP_MUXER)           += filmstripenc.o
OBJS-$(CONFIG_FLAC_DEMUXER)              += flacdec.o rawdec.o \
                                            flac_picture.o   \
                                            oggparsevorbis.o \
                                            vorbiscomment.o
OBJS-$(CONFIG_FLAC_MUXER)                += flacenc.o flacenc_header.o \
                                            vorbiscomment.o
OBJS-$(CONFIG_FLIC_DEMUXER)              += flic.o
OBJS-$(CONFIG_FLV_DEMUXER)               += flvdec.o
OBJS-$(CONFIG_FLV_MUXER)                 += flvenc.o avc.o
OBJS-$(CONFIG_FOURXM_DEMUXER)            += 4xm.o
OBJS-$(CONFIG_FRAMECRC_MUXER)            += framecrcenc.o framehash.o
OBJS-$(CONFIG_FRAMEMD5_MUXER)            += md5enc.o framehash.o
OBJS-$(CONFIG_GIF_MUXER)                 += gif.o
OBJS-$(CONFIG_GSM_DEMUXER)               += gsmdec.o
OBJS-$(CONFIG_GXF_DEMUXER)               += gxf.o
OBJS-$(CONFIG_GXF_MUXER)                 += gxfenc.o audiointerleave.o
OBJS-$(CONFIG_G722_DEMUXER)              += g722.o rawdec.o
OBJS-$(CONFIG_G722_MUXER)                += rawenc.o
OBJS-$(CONFIG_G723_1_DEMUXER)            += g723_1.o
OBJS-$(CONFIG_H261_DEMUXER)              += h261dec.o rawdec.o
OBJS-$(CONFIG_H261_MUXER)                += rawenc.o
OBJS-$(CONFIG_H263_DEMUXER)              += h263dec.o rawdec.o
OBJS-$(CONFIG_H263_MUXER)                += rawenc.o
OBJS-$(CONFIG_H264_DEMUXER)              += h264dec.o rawdec.o
OBJS-$(CONFIG_H264_MUXER)                += rawenc.o
OBJS-$(CONFIG_HDS_MUXER)                 += hdsenc.o
OBJS-$(CONFIG_HEVC_DEMUXER)              += hevcdec.o rawdec.o
OBJS-$(CONFIG_HEVC_MUXER)                += rawenc.o
OBJS-$(CONFIG_HLS_DEMUXER)               += hls.o
OBJS-$(CONFIG_HLS_MUXER)                 += hlsenc.o
OBJS-$(CONFIG_HNM_DEMUXER)               += hnm.o
OBJS-$(CONFIG_IDCIN_DEMUXER)             += idcin.o
OBJS-$(CONFIG_IFF_DEMUXER)               += iff.o
OBJS-$(CONFIG_ILBC_DEMUXER)              += ilbc.o
OBJS-$(CONFIG_ILBC_MUXER)                += ilbc.o
OBJS-$(CONFIG_IMAGE2_DEMUXER)            += img2dec.o img2.o
OBJS-$(CONFIG_IMAGE2_MUXER)              += img2enc.o img2.o
OBJS-$(CONFIG_IMAGE2PIPE_DEMUXER)        += img2dec.o img2.o
OBJS-$(CONFIG_IMAGE2PIPE_MUXER)          += img2enc.o img2.o
OBJS-$(CONFIG_INGENIENT_DEMUXER)         += ingenientdec.o rawdec.o
OBJS-$(CONFIG_IPMOVIE_DEMUXER)           += ipmovie.o
OBJS-$(CONFIG_ISS_DEMUXER)               += iss.o
OBJS-$(CONFIG_IV8_DEMUXER)               += iv8.o
OBJS-$(CONFIG_IVF_DEMUXER)               += ivfdec.o
OBJS-$(CONFIG_IVF_MUXER)                 += ivfenc.o
OBJS-$(CONFIG_JV_DEMUXER)                += jvdec.o
OBJS-$(CONFIG_LATM_DEMUXER)              += rawdec.o
OBJS-$(CONFIG_LATM_MUXER)                += latmenc.o
OBJS-$(CONFIG_LMLM4_DEMUXER)             += lmlm4.o
OBJS-$(CONFIG_LXF_DEMUXER)               += lxfdec.o
OBJS-$(CONFIG_M4V_DEMUXER)               += m4vdec.o rawdec.o
OBJS-$(CONFIG_M4V_MUXER)                 += rawenc.o
OBJS-$(CONFIG_MATROSKA_DEMUXER)          += matroskadec.o matroska.o  \
                                            isom.o rmsipr.o
OBJS-$(CONFIG_MATROSKA_MUXER)            += matroskaenc.o matroska.o \
                                            isom.o avc.o hevc.o \
                                            flacenc_header.o avlanguage.o wv.o
OBJS-$(CONFIG_MD5_MUXER)                 += md5enc.o
OBJS-$(CONFIG_MJPEG_DEMUXER)             += rawdec.o
OBJS-$(CONFIG_MJPEG_MUXER)               += rawenc.o
OBJS-$(CONFIG_MLP_DEMUXER)               += rawdec.o
OBJS-$(CONFIG_MLP_MUXER)                 += rawenc.o
OBJS-$(CONFIG_MM_DEMUXER)                += mm.o
OBJS-$(CONFIG_MMF_DEMUXER)               += mmf.o pcm.o
OBJS-$(CONFIG_MMF_MUXER)                 += mmf.o
OBJS-$(CONFIG_MOV_DEMUXER)               += mov.o isom.o mov_chan.o
OBJS-$(CONFIG_MOV_MUXER)                 += movenc.o isom.o avc.o hevc.o \
                                            movenchint.o mov_chan.o
OBJS-$(CONFIG_MP2_MUXER)                 += mp3enc.o rawenc.o id3v2enc.o
OBJS-$(CONFIG_MP3_DEMUXER)               += mp3dec.o
OBJS-$(CONFIG_MP3_MUXER)                 += mp3enc.o rawenc.o id3v2enc.o
OBJS-$(CONFIG_MPC_DEMUXER)               += mpc.o apetag.o img2.o
OBJS-$(CONFIG_MPC8_DEMUXER)              += mpc8.o apetag.o img2.o
OBJS-$(CONFIG_MPEG1SYSTEM_MUXER)         += mpegenc.o
OBJS-$(CONFIG_MPEG1VCD_MUXER)            += mpegenc.o
OBJS-$(CONFIG_MPEG2DVD_MUXER)            += mpegenc.o
OBJS-$(CONFIG_MPEG2VOB_MUXER)            += mpegenc.o
OBJS-$(CONFIG_MPEG2SVCD_MUXER)           += mpegenc.o
OBJS-$(CONFIG_MPEG1VIDEO_MUXER)          += rawenc.o
OBJS-$(CONFIG_MPEG2VIDEO_MUXER)          += rawenc.o
OBJS-$(CONFIG_MPEGPS_DEMUXER)            += mpeg.o
OBJS-$(CONFIG_MPEGTS_DEMUXER)            += mpegts.o isom.o
OBJS-$(CONFIG_MPEGTS_MUXER)              += mpegtsenc.o
OBJS-$(CONFIG_MPEGVIDEO_DEMUXER)         += mpegvideodec.o rawdec.o
OBJS-$(CONFIG_MPJPEG_MUXER)              += mpjpeg.o
OBJS-$(CONFIG_MSNWC_TCP_DEMUXER)         += msnwc_tcp.o
OBJS-$(CONFIG_MTV_DEMUXER)               += mtv.o
OBJS-$(CONFIG_MVI_DEMUXER)               += mvi.o
OBJS-$(CONFIG_MXF_DEMUXER)               += mxfdec.o mxf.o
OBJS-$(CONFIG_MXF_MUXER)                 += mxfenc.o mxf.o audiointerleave.o
OBJS-$(CONFIG_MXG_DEMUXER)               += mxg.o
OBJS-$(CONFIG_NC_DEMUXER)                += ncdec.o
OBJS-$(CONFIG_NSV_DEMUXER)               += nsvdec.o
OBJS-$(CONFIG_NULL_MUXER)                += nullenc.o
OBJS-$(CONFIG_NUT_DEMUXER)               += nutdec.o nut.o
OBJS-$(CONFIG_NUT_MUXER)                 += nutenc.o nut.o
OBJS-$(CONFIG_NUV_DEMUXER)               += nuv.o
OBJS-$(CONFIG_OGG_DEMUXER)               += oggdec.o         \
                                            oggparsecelt.o   \
                                            oggparsedirac.o  \
                                            oggparseflac.o   \

=== libavcodec/aarch64/Makefile ===
OBJS-$(CONFIG_H264CHROMA)               += aarch64/h264chroma_init_aarch64.o
OBJS-$(CONFIG_H264DSP)                  += aarch64/h264dsp_init_aarch64.o
OBJS-$(CONFIG_H264QPEL)                 += aarch64/h264qpel_init_aarch64.o
OBJS-$(CONFIG_HPELDSP)                  += aarch64/hpeldsp_init_aarch64.o
OBJS-$(CONFIG_NEON_CLOBBER_TEST)        += aarch64/neontest.o
OBJS-$(CONFIG_RV40_DECODER)             += aarch64/rv40dsp_init_aarch64.o
OBJS-$(CONFIG_VC1_DECODER)              += aarch64/vc1dsp_init_aarch64.o

NEON-OBJS-$(CONFIG_H264CHROMA)          += aarch64/h264cmc_neon.o
NEON-OBJS-$(CONFIG_H264DSP)             += aarch64/h264dsp_neon.o              \
                                           aarch64/h264idct_neon.o
NEON-OBJS-$(CONFIG_H264QPEL)            += aarch64/h264qpel_neon.o             \
                                           aarch64/hpeldsp_neon.o
NEON-OBJS-$(CONFIG_HPELDSP)             += aarch64/hpeldsp_neon.o

=== libavcodec/arm/Makefile ===
ARCH_HEADERS = mathops.h

OBJS                                   += arm/fmtconvert_init_arm.o

OBJS-$(CONFIG_AAC_DECODER)             += arm/aacpsdsp_init_arm.o       \
                                          arm/sbrdsp_init_arm.o
OBJS-$(CONFIG_AC3DSP)                  += arm/ac3dsp_init_arm.o         \
                                          arm/ac3dsp_arm.o
OBJS-$(CONFIG_DCA_DECODER)             += arm/dcadsp_init_arm.o
OBJS-$(CONFIG_DSPUTIL)                 += arm/dsputil_init_arm.o        \
                                          arm/dsputil_arm.o             \
                                          arm/jrevdct_arm.o             \
                                          arm/simple_idct_arm.o
OBJS-$(CONFIG_FFT)                     += arm/fft_init_arm.o            \
                                          arm/fft_fixed_init_arm.o
OBJS-$(CONFIG_FLAC_DECODER)            += arm/flacdsp_init_arm.o        \
                                          arm/flacdsp_arm.o
OBJS-$(CONFIG_H264CHROMA)              += arm/h264chroma_init_arm.o
OBJS-$(CONFIG_H264DSP)                 += arm/h264dsp_init_arm.o
OBJS-$(CONFIG_H264PRED)                += arm/h264pred_init_arm.o
OBJS-$(CONFIG_H264QPEL)                += arm/h264qpel_init_arm.o
OBJS-$(CONFIG_HPELDSP)                 += arm/hpeldsp_init_arm.o        \
                                          arm/hpeldsp_arm.o
OBJS-$(CONFIG_MPEGAUDIODSP)            += arm/mpegaudiodsp_init_arm.o
OBJS-$(CONFIG_MPEGVIDEO)               += arm/mpegvideo_arm.o
OBJS-$(CONFIG_NEON_CLOBBER_TEST)       += arm/neontest.o
OBJS-$(CONFIG_VC1_DECODER)             += arm/vc1dsp_init_arm.o
OBJS-$(CONFIG_VORBIS_DECODER)          += arm/vorbisdsp_init_arm.o
OBJS-$(CONFIG_VP3DSP)                  += arm/vp3dsp_init_arm.o
OBJS-$(CONFIG_VP6_DECODER)             += arm/vp6dsp_init_arm.o
OBJS-$(CONFIG_VP8_DECODER)             += arm/vp8dsp_init_arm.o
OBJS-$(CONFIG_RV30_DECODER)            += arm/rv34dsp_init_arm.o
OBJS-$(CONFIG_RV40_DECODER)            += arm/rv34dsp_init_arm.o        \
                                          arm/rv40dsp_init_arm.o
OBJS-$(CONFIG_VIDEODSP)                += arm/videodsp_init_arm.o       \

ARMV5TE-OBJS-$(CONFIG_DSPUTIL)         += arm/dsputil_init_armv5te.o    \
                                          arm/simple_idct_armv5te.o
ARMV5TE-OBJS-$(CONFIG_MPEGVIDEO)       += arm/mpegvideo_armv5te.o       \
                                          arm/mpegvideo_armv5te_s.o
ARMV5TE-OBJS-$(CONFIG_VIDEODSP)        += arm/videodsp_init_armv5te.o   \
                                          arm/videodsp_armv5te.o

ARMV6-OBJS-$(CONFIG_DSPUTIL)           += arm/dsputil_init_armv6.o      \
                                          arm/dsputil_armv6.o           \
                                          arm/simple_idct_armv6.o       \

ARMV6-OBJS-$(CONFIG_AC3DSP)            += arm/ac3dsp_armv6.o
ARMV6-OBJS-$(CONFIG_H264DSP)           += arm/h264dsp_armv6.o
ARMV6-OBJS-$(CONFIG_HPELDSP)           += arm/hpeldsp_init_armv6.o      \
                                          arm/hpeldsp_armv6.o
ARMV6-OBJS-$(CONFIG_MPEGAUDIODSP)      += arm/mpegaudiodsp_fixed_armv6.o
ARMV6-OBJS-$(CONFIG_VP8_DECODER)       += arm/vp8_armv6.o               \
                                          arm/vp8dsp_init_armv6.o       \
                                          arm/vp8dsp_armv6.o

VFP-OBJS                               += arm/fmtconvert_vfp.o

VFP-OBJS-$(CONFIG_DCA_DECODER)         += arm/dcadsp_vfp.o              \
                                          arm/synth_filter_vfp.o
VFP-OBJS-$(CONFIG_FFT)                 += arm/fft_vfp.o
VFP-OBJS-$(CONFIG_MDCT)                += arm/mdct_vfp.o
VFP-OBJS-$(HAVE_ARMV6)                 += arm/fmtconvert_vfp_armv6.o

NEON-OBJS                              += arm/fmtconvert_neon.o

NEON-OBJS-$(CONFIG_AC3DSP)             += arm/ac3dsp_neon.o
NEON-OBJS-$(CONFIG_AAC_DECODER)        += arm/aacpsdsp_neon.o           \
                                          arm/sbrdsp_neon.o
NEON-OBJS-$(CONFIG_DCA_DECODER)        += arm/dcadsp_neon.o             \
                                          arm/synth_filter_neon.o
NEON-OBJS-$(CONFIG_DSPUTIL)            += arm/dsputil_init_neon.o       \
                                          arm/dsputil_neon.o            \
                                          arm/int_neon.o                \
                                          arm/simple_idct_neon.o
NEON-OBJS-$(CONFIG_FFT)                += arm/fft_neon.o                \
                                          arm/fft_fixed_neon.o
NEON-OBJS-$(CONFIG_H264CHROMA)         += arm/h264cmc_neon.o
NEON-OBJS-$(CONFIG_H264DSP)            += arm/h264dsp_neon.o            \
                                          arm/h264idct_neon.o
NEON-OBJS-$(CONFIG_H264PRED)           += arm/h264pred_neon.o
NEON-OBJS-$(CONFIG_H264QPEL)           += arm/h264qpel_neon.o           \
                                          arm/hpeldsp_neon.o
NEON-OBJS-$(CONFIG_HPELDSP)            += arm/hpeldsp_init_neon.o       \
                                          arm/hpeldsp_neon.o
NEON-OBJS-$(CONFIG_MDCT)               += arm/mdct_neon.o               \
                                          arm/mdct_fixed_neon.o
NEON-OBJS-$(CONFIG_MPEGVIDEO)          += arm/mpegvideo_neon.o
NEON-OBJS-$(CONFIG_RDFT)               += arm/rdft_neon.o
NEON-OBJS-$(CONFIG_RV30_DECODER)       += arm/rv34dsp_neon.o
NEON-OBJS-$(CONFIG_RV40_DECODER)       += arm/rv34dsp_neon.o            \
                                          arm/rv40dsp_neon.o
NEON-OBJS-$(CONFIG_VC1_DECODER)        += arm/vc1dsp_init_neon.o        \
                                          arm/vc1dsp_neon.o
NEON-OBJS-$(CONFIG_VORBIS_DECODER)     += arm/vorbisdsp_neon.o
NEON-OBJS-$(CONFIG_VP3DSP)             += arm/vp3dsp_neon.o
NEON-OBJS-$(CONFIG_VP6_DECODER)        += arm/vp6dsp_neon.o
NEON-OBJS-$(CONFIG_VP8_DECODER)        += arm/vp8dsp_init_neon.o        \
                                          arm/vp8dsp_neon.o

=== libavcodec/bfin/Makefile ===
OBJS += bfin/dsputil_bfin.o                                             \
        bfin/fdct_bfin.o                                                \
        bfin/idct_bfin.o                                                \
        bfin/pixels_bfin.o                                              \

OBJS-$(CONFIG_HPELDSP)                  += bfin/hpeldsp_bfin.o          \
                                           bfin/hpel_pixels_bfin.o
OBJS-$(CONFIG_VP3DSP)                   += bfin/vp3_bfin.o              \
                                           bfin/vp3_idct_bfin.o

=== debian/changelog ===
libav (6:10.1-1~bpo70+1) wheezy-backports; urgency=medium

  * Rebuild for wheezy-backports.
  * Loosen build-dependency on libfreetype-dev

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 01 Jun 2014 17:46:13 -0400

libav (6:10.1-1) unstable; urgency=low

  * New upstream release 10:
     - pcm-dvd: Fix 20bit decoding (bug/592)
     - avi: Improve non-interleaved detection (bug/666)
     - arm: hpeldsp: fix put_pixels8_y2_{,no_rnd_}armv6
     - arm: hpeldsp: prevent overreads in armv6 asm (bug/646)
     - avfilter: Add missing emms_c when needed
     - rtmpproto: Check the buffer sizes when copying app/playpath strings
     - swscale: Fix an undefined behaviour
     - vp9: Read the frame size as unsigned
     - dcadec: Use correct channel count in stereo downmix check
     - dcadec: Do not decode the XCh extension when downmixing to stereo
     - matroska: add the Opus mapping
     - matroskadec: read the CodecDelay element
     - rtmpproto: Make sure to pass on the error code if read_connect failed
     - lavr: allocate the resampling buffer with a positive size
     - mp3enc: Properly write bitrate value in XING header (Closes: #736088)
     - golomb: Fix the implementation of get_se_golomb_long
  * Drop debian/libav-tools.maintscript. ffserver is no longer found in
    stable, and this seems to cause other problems today (Closes: #742676)

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 11 May 2014 12:28:45 -0400

libav (6:10-2) experimental; urgency=low

  * Recompile against libx264-142 and librtmp1
  * Bump standards version, no changes needed
  * Drop Andres Meija from uploaders. Thanks Andres for your contributions
    to the libav package! (Closes: #743526).

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 12 Apr 2014 08:44:31 -0400

libav (6:10-1) experimental; urgency=low

  * New upstream release 10. Full changelog avaialble at:
    http://git.libav.org/?p=libav.git;a=blob;f=Changelog;hb=refs/tags/v10

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 23 Mar 2014 14:23:55 -0400

libav (6:10~beta2-2) experimental; urgency=low

  * Drop unnecessary packages: libavformat-extra-, libavutil-extra,
    libavfilter-extra and libavdevice-extra.
  * Incorporate post-beta2 patches, including the icy header detection
    patches (Closes: #740421)
  * Add a note about 'ffmpeg' in libav-tools's package description
    (Closes: #729469)

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 15 Mar 2014 14:46:20 +0000

libav (6:10~beta2-1) experimental; urgency=low

  * New Upstream release 10_beta2. This upstream git snapshot has too many
    changes to list here, cf. to the upstream Changelog:
    http://git.libav.org/?p=libav.git;a=blob;f=Changelog;hb=refs/tags/v10_beta2

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 15 Mar 2014 00:34:08 +0000

libav (6:10~beta1-2) experimental; urgency=low

  * New Upstream release 10_beta1. This upstream git snapshot has too many
    changes to list here, cf. to the upstream Changelog:
    http://git.libav.org/?p=libav.git;a=blob;f=Changelog;hb=refs/tags/v10_beta1
    - works with H.264 that has different bit depth between chroma and luma,
      Closes: #738599
  * Bump shlibs

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 17 Feb 2014 22:07:03 +0000

libav (6:10~alpha2-1) experimental; urgency=low

  * New Upstream release 10_alpha2. This upstream git snapshot has too many
    changes to list here, cf. to the upstream Changelog:
    http://git.libav.org/?p=libav.git;a=blob;f=Changelog;hb=refs/tags/v10_alpha2

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 18 Jan 2014 15:46:55 +0000

libav (6:10~alpha1-1) experimental; urgency=low

  * New Upstream release 10_alpha1. This upstream git snapshot has too many
    changes to list here, cf. to the upstream Changelog:
    http://git.libav.org/?p=libav.git;a=blob;f=Changelog;hb=refs/tags/v10_alpha1
    - Opus in Ogg demuxing Closes: #733884, #720563, LP: #1265196
    - avprobe output is now standard INI or JSON. Closes: #715467
    - Properly working defaults in libx264 wrapper, Closes: #687048
    - avconv -t option can now be used for inputs, to limit the duration of
      data read from an input file, Closes: #722003

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 18 Dec 2013 15:16:03 +0000

libav (6:9.13-1~bpo70+1) wheezy-backports; urgency=low

  * Rebuild for wheezy-backports.
  * Loosen build dependency requirement on libfreetype-dev to fix FTBFS

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 05 Jan 2014 15:05:35 -0500

libav (6:9.13-1) unstable; urgency=medium

  * New upstream release 9.13:
    - swscale: Fix an undefined behaviour
    - matroska: add the Opus mapping
    - mp3enc: Properly write bitrate value in XING header (Closes: #736088)
    - origin/pu/9 oggdec: add support for Opus in Ogg demuxing
      (Fixes: libav/603, Closes: #720563)
    - apedec: do not buffer decoded samples over AVPackets (Closes: #744901)
    - isom: lpcm in mov default to big endian
    - movdec: handle 0x7fff langcode as macintosh per the specs
    - h264: reset next_output_pic earlier in start_frame()
      (Fixes: libav/672, Closes: #741240, LP: #1288206)
    - rtmpproto: Make sure to pass on the error code if read_connect failed
    - lavr: allocate the resampling buffer with a positive size
    - tiffdec: use bytestream2 to simplify overread/overwrite protection
    - resample: fix avresample_get_delay() return value
    - avi: Improve non-interleaved detection (Fixes: libav/666)
    - af_channelmap: fix ONE_STR mapping mode
    - movenc: allow override of "writing application" tag
    - matroskaenc: allow override of "writing application" tag
    - avfilter: Add missing emms_c when needed
    - build: Use pkg-config for openjpeg (Fixes: libav/387)
    - mpeg12: check scantable indices in all decode_block functions
    - sgidec: fix buffer size check in expand_rle_row()
    - adx: check that the offset is not negative
    - mpegvideo: set reference/pict_type on generated reference frames


=== debian/control ===
Source: libav
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Sam Hocevar (Debian packages) <sam+deb@zoy.org>,
 Loïc Minier <lool@debian.org>,
 Reinhard Tartler <siretart@tauware.de>,
 Fabian Greffrath <fabian+debian@greffrath.com>,
 Jonas Smedegaard <dr@jones.dk>
Standards-Version: 3.9.5
Vcs-Git: git://anonscm.debian.org/pkg-multimedia/libav.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/libav.git;a=summary
Homepage: http://libav.org/
Build-Depends-Indep:
 doxygen
Build-Depends:
 debhelper (>= 9),
 frei0r-plugins-dev,
 libasound2-dev [linux-any],
 libbz2-dev,
 libcdio-cdda-dev,
 libcdio-dev,
 libcdio-paranoia-dev,
 libdc1394-22-dev [linux-any],
 libfreetype6-dev,
 libgnutls-dev,
 libgsm1-dev,
 libjack-dev,
 libmp3lame-dev,
 libopencore-amrnb-dev,
 libopencore-amrwb-dev,
 libopencv-dev,
 libopenjpeg-dev,
 libopus-dev (>= 1.0.1),
 libpulse-dev,
 libraw1394-dev [linux-any],
 librtmp-dev (>= 2.2e-4),
 libschroedinger-dev,
 libsdl1.2-dev,
 libspeex-dev,
 libtheora-dev (>> 0.0.0.alpha4),
 libtiff-dev,
 libva-dev [!hurd-any],
 libvdpau-dev,
 libvo-aacenc-dev,
 libvo-amrwbenc-dev,
 libvorbis-dev,
 libvpx-dev,
 libx11-dev,
 libx264-dev,
 libxext-dev,
 libxfixes-dev,
 libxvidcore-dev,
 libxvmc-dev,
 texi2html,
 yasm [any-amd64 any-i386],
 zlib1g-dev

Package: libav-tools
Section: video
Architecture: any
Replaces:
 libavcodec-extra-53 (<< 4:0.6~)
Pre-Depends:
 ${misc:Pre-Depends},
 dpkg (>= 1.15.7.2~)
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 frei0r-plugins (>= 1.3)
Conflicts:
 ffprobe
Description: Multimedia player, server, encoder and transcoder
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This package contains the avplay multimedia player, the avserver
 streaming server, the avconv audio and video encoder, and the avprobe
 stream analyzer.  They support most existing file formats (AVI, MPEG,
 OGG, Matroska, ASF...) and encoding formats (MPEG, DivX, MPEG4, AC3,
 DV...). Additionally, it contains the qt-faststart utility which
 rearranges Quicktime files to facilitate network streaming.
 .
 This package replaces the 'ffmpeg' command-line tool that was provided
 in earlier distroreleases.

Package: libav-dbg
Section: debug
Priority: extra
Architecture: any
Replaces:
 ffmpeg-dbg (<< 6:0.8.3-5),
 libav-extra-dbg (<< 6:0.8.3-5)
Breaks:
 ffmpeg-dbg (<< 6:0.8.3-5),
 libav-extra-dbg (<< 6:0.8.3-5)
Depends:
 libav-tools (= ${binary:Version}),
 libavcodec55 (= ${binary:Version}) | libavcodec-extra-55 (= ${binary:Version}),
 libavdevice54 (= ${binary:Version}),
 libavformat55 (= ${binary:Version}),
 libavutil53 (= ${binary:Version}),
 libswscale2 (= ${binary:Version}),
 ${misc:Depends}
Description: Debug symbols for Libav related packages
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This package contains debug data of the Libav related shared libraries.
 .
 Most people will not need this package. Please install it to produce useful
 stacktraces to help debugging the Libav library.

Package: libav-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends}
Description: Documentation of the Libav API
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This package contains the html doxygen documentation of the Libav API.
 .
 Only application developers will find this package useful.

Package: libavutil53
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Libav utility library
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the common utility library from Libav. It contains shared code
 used by all other Libav libraries.

Package: libavcodec55
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Conflicts:
 libavcodec-extra-55
Replaces:
 libavcodec-extra-55
Breaks:
 mplayer (<< 2:1.0~rc4.dfsg1+svn34540-1~)
Description: Libav codec library
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the codec library from Libav (both encoding and decoding).
 .
 It supports most existing codecs (MPEG, MPEG2, MPEG4, AC3, DV...).

Package: libavdevice54
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Libav device handling library
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the device handling library from Libav.

Package: libavformat55
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Libav file format library
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the library for handling file formats from Libav.
 .
 It supports most existing file formats (AVI, MPEG, OGG, Matroska,
 ASF...).

Package: libavfilter4
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 frei0r-plugins (>= 1.3)
Description: Libav video filtering library
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the video filtering library from Libav.

Package: libswscale2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Replaces:
 libswscale-extra-2
Breaks:
 libswscale-extra-2 (<< 5:0.8.1-2)
Description: Libav video scaling library
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the video software scaling library from Libav.

Package: libavutil-dev
Section: libdevel
Architecture: any
Depends:
 libavutil53 (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for libavutil
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the common utility library from Libav.
 .
 This package contains the header files and static libraries needed to
 compile applications or shared objects that use libavutil.

Package: libavcodec-dev
Section: libdevel
Architecture: any
Depends:
 libavcodec55 (<= ${source:Upstream-Version}-99) | libavcodec-extra-55 (<= ${source:Upstream-Version}-99),
 libavcodec55 (>= ${binary:Version}) | libavcodec-extra-55 (>= ${binary:Version}),
 libavutil-dev (= ${binary:Version}),
 ${misc:Depends}
Suggests:
 libdc1394-22-dev [linux-any],
 libgsm1-dev,
 libogg-dev,
 libraw1394-dev [linux-any],
 libschroedinger-dev,
 libspeex-dev,
 libtheora-dev (>> 0.0.0.alpha4),
 libvorbis-dev,
 libx11-dev,
 libxext-dev,
 zlib1g-dev
Description: Development files for libavcodec
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the codec library from Libav. It supports most existing
 encoding formats (MPEG, DivX, MPEG4, AC3, DV...).
 .
 This package contains the header files and static libraries needed to
 compile applications or shared objects that use libavcodec.

Package: libavdevice-dev
Section: libdevel
Architecture: any
Depends:
 libavdevice54 (= ${binary:Version}),
 libavformat-dev (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for libavdevice
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the device handling library from Libav.
 .
 This package contains the header files and static libraries needed to
 compile applications or shared objects that use libavdevice.

Package: libavformat-dev
Section: libdevel
Architecture: any
Depends:
 libavcodec-dev (= ${binary:Version}),
 libavformat55 (= ${binary:Version}),
 libavutil-dev (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for libavformat
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the demuxer library from Libav. It supports most
 existing file formats (AVI, MPEG, OGG, Matroska, ASF...).
 .
 This package contains the header files and static libraries needed to
 compile applications or shared objects that use libavformat.

Package: libavfilter-dev
Section: libdevel
Architecture: any
Depends:
 libavcodec-dev (= ${binary:Version}),
 libavfilter4 (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for libavfilter
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the video filtering library from Libav.
 .
 This package contains the header files and static libraries needed to
 compile applications or shared objects that use libavfilter.

Package: libswscale-dev
Section: libdevel
Architecture: any
Depends:
 libavutil-dev (= ${binary:Version}),
 libswscale2 (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for libswscale
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the video scaling library from Libav.
 .
 This package contains the header files and static libraries needed to
 compile applications or shared objects that use libswscale.

Package: libavresample-dev
Section: libdevel
Architecture: any
Depends:
 libavutil-dev (= ${binary:Version}),
 libavresample1 (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for libavresample
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the video scaling library from Libav.
 .
 This package contains the header files and static libraries needed to
 compile applications or shared objects that use libswrescale.

Package: libavresample1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Replaces:
 libavresample0
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Libav audio resampling library
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the audio software resampling library from Libav.

Package: libavcodec-extra-55
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Replaces:
 libavcodec55
Conflicts:
 libavcodec55
Breaks:
 mplayer (<< 2:1.0~rc4.dfsg1+svn34540-1~)
Description: Libav codec library (additional codecs)
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This is the codec library from Libav (both encoding and decoding).
 .
 This package is a replacement for the regular libavcodec55 library package;
 it contains the following additional codecs:
 .
  * OpenCORE Adaptive Multi-Rate (AMR) Narrow-Band (Encoder/Decoder)
  * OpenCORE Adaptive Multi-Rate (AMR) Wide-Band (Decoder)
  * Android VisualOn AAC (Encoder)
  * Android VisualOn Adaptive Multi-Rate (AMR) Wide-Band (Encoder)
 .
 Because this package links against libraries that are licensed under
 Apache License 2.0, the resulting binaries are distributed under the
 GPL version 3 or later.

Package: libavcodec-extra
Priority: extra
Architecture: all
Depends:
 libavcodec-extra-55,
 ${misc:Depends},
Description: Libav codec library (additional codecs meta-package)
 Libav is a complete, cross-platform solution to decode, encode, record,
 convert and stream audio and video.
 .
 This package depends on the latest version of the libavcodec variant
 that offers additional codec support. Application packages can depend
 on it if they require or suggest this variant in a robust manner.

=== debian/rules ===
#!/usr/bin/make -f

EPOCH=6:
DEB_SOURCE := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
DEB_VERSION := $(shell dpkg-parsechangelog | sed -n 's/^Version: //p')
UPSTREAM_VERSION := $(shell echo $(DEB_VERSION) | sed -r 's/[^:]+://; s/-[^-]+$$//')
SHLIBS_VERSION := $(EPOCH)10~beta1~

# The libavcodec-extra package is necessary because it links against
# libraries that are GPLv3 licensed. Make sure that you do not link
# GPLv2 only applications against the libavcodec-extra flavor!
#
# Because of the lack of archive skew problems, only libavcodec produces
# an -extra variant.

VENDOR := Debian
# these package do not build -extra variants
LIB_PKGS := $(shell sed -nr 's/^Package:[[:space:]]*(lib(avutil|avdevice|avformat|avfilter|avresample|swscale)[0-9]+)[[:space:]]*$$/\1/p' debian/control)
# these packages do build -extra variants
LIB_PKGS2 := $(shell sed -nr 's/^Package:[[:space:]]*(libavcodec[0-9]+)[[:space:]]*$$/\1/p' debian/control)
# these packages are the -extra- variants
LIB_EXTRA_PKGS := $(shell sed -nr 's/^Package:[[:space:]]*(libavcodec-extra-[0-9]+)[[:space:]]*$$/\1/p' debian/control)


# these are the -dev packages
DEV_PKGS := $(shell echo $(LIB_PKGS) $(LIB_PKGS2) | sed 's/[0-9]\+\>/-dev/g')

# Support multiple makes at once
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS = -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
# on i386 and amd64, we query the system unless overriden by DEB_BUILD_OPTIONS
ifeq      ($(DEB_HOST_ARCH),i386)
NUMJOBS := -j$(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
else ifeq ($(DEB_HOST_ARCH),amd64)
NUMJOBS := -j$(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
endif
endif

include debian/confflags
OPT_FLAVORS := $(filter-out static shared, $(FLAVORS))

info:
	@echo Packages that do not build -extra variants: $(LIB_PKGS)
	@echo Packages that do build -extra variatnts: $(LIB_PKGS2)
	@echo Packages that are the -extra- variants: $(LIB_EXTRA_PKGS)

$(info FLAVORS = $(FLAVORS))
$(info DEB_BUILD_OPTIONS = $(DEB_BUILD_OPTIONS))
$(info CFLAGS = $(CFLAGS))
$(info CPPFLAGS = $(CPPFLAGS))
$(info LDFLAGS = $(LDFLAGS))

define dh_install_file_opt_flavor
	  grep @DEB_HOST_MULTIARCH_OPT@ < $(1).in | \
	  sed 's:@DEB_HOST_MULTIARCH_OPT@:$(DEB_HOST_MULTIARCH)/$($(2)_shlibdir):g' >> $(1)

endef

DH_INSTALL_FILES := $(foreach pkg, $(LIB_PKGS) $(LIB_PKGS2) $(LIB_EXTRA_PKGS) $(DEV_PKGS), debian/$(pkg).install)
$(DH_INSTALL_FILES):
	sed 's/@DEB_HOST_MULTIARCH\(_OPT\)\?@/$(DEB_HOST_MULTIARCH)/g' $@.in > $@
	$(foreach opt_flavor,$(OPT_FLAVORS),$(call dh_install_file_opt_flavor,$@,$(opt_flavor)))

configure-%: configure-stamp-%
configure-stamp-%: configure
	dh_testdir
	mkdir -p debian-$*
	cd debian-$* && CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="$(LDFLAGS)" $(CURDIR)/configure \
		$($*_build_confflags) $(extra_$*_build_confflags)
	touch $@
configure-extra-stamp-%:
	dh_testdir
	mkdir -p debian-extra-$*
	cd debian-extra-$* && CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="$(LDFLAGS)" $(CURDIR)/configure \
		$($*_build_confflags) $(v3_confflags) $(extra_$*_build_confflags)
	touch $@

build-%: build-stamp-%
build-stamp-%: configure-stamp-%
	dh_testdir
	$(MAKE) -C debian-$* $(NUMJOBS) V=1
	touch $@
build-extra-stamp-%: configure-extra-stamp-%
	dh_testdir
	$(MAKE) -C debian-extra-$* $(NUMJOBS) V=1
	touch $@

debian-shared/tools/qt-faststart: build-stamp-shared
	$(MAKE) -C debian-shared tools/qt-faststart V=1

build: build-stamp build-extra
build-stamp: $(addprefix build-stamp-, $(FLAVORS)) debian-shared/tools/qt-faststart
	touch $@
build-extra: $(addprefix build-extra-stamp-, $(filter-out static,$(FLAVORS)))
	touch $@

clean:
	dh_testdir
	rm -f build-stamp build-extra $(addprefix build-stamp-, $(FLAVORS)) \
	    $(addprefix build-extra-stamp-, $(FLAVORS)) \
	    $(addprefix configure-stamp-, $(FLAVORS)) \
	    $(addprefix configure-extra-stamp-, $(FLAVORS)) \
	    build-doxy-stamp
	rm -rf libav/ # created by the libav-extra variant
	rm -rf $(addprefix debian-, $(FLAVORS)) \
		$(addprefix debian-extra-, $(FLAVORS)) doxy
	dh_clean $(DH_INSTALL_FILES) $(wildcard formats*.txt) $(wildcard codecs*.txt)

# The trailing newline is important!
define install_flavor
	$(MAKE) -C debian-$(1) install DESTDIR=$(CURDIR)/debian/tmp \
	    mandir=$(CURDIR)/debian/tmp/usr/share/man

endef

# The trailing newline is important!
define install_flavor_extra
	$(MAKE) -C debian-extra-$(1) install DESTDIR=$(CURDIR)/debian/tmp/extra \
	    mandir=$(CURDIR)/debian/tmp/usr/share/man

endef

# usage $(call call_and_install_avconv_dump,$package,$parameter), paramter like "codecs" or "formats"
define call_and_install_avconv_dump
	mkdir -p debian/$(1)/usr/share/doc/$(1)
	env LD_LIBRARY_PATH="$(CURDIR)/debian/$(1)/usr/lib/$(DEB_HOST_MULTIARCH):$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH):$(LD_LIBRARY_PATH)" \
	debian/tmp/usr/bin/avconv -$(2) > debian/$(1)/usr/share/doc/$(1)/$(2)-$(DEB_HOST_ARCH).txt
	cat debian/$(1)/usr/share/doc/$(1)/$(2)-$(DEB_HOST_ARCH).txt

endef

# installs arch-dependent files only
install: build $(DH_INSTALL_FILES)
	dh_testdir
	dh_testroot
	dh_prep -a
	$(foreach flavor,$(FLAVORS),$(call install_flavor,$(flavor)))
	mkdir -p debian/tmp/etc
	install -m 644 -D doc/avserver.conf debian/tmp/etc/
	install -m 755 -D debian-shared/tools/qt-faststart debian/tmp/usr/bin/qt-faststart
	dh_install $(addprefix -N,$(LIB_EXTRA_PKGS)) \
		 --fail-missing --sourcedir=debian/tmp
	dh_installdocs -a doc/APIchanges
	install -m 644 -D debian-shared/doc/*.html doc/t2h.init debian/libav-tools/usr/share/doc/libav-tools
	dh_installexamples -a
	dh_installchangelogs -a Changelog
	$(foreach flavor,$(filter-out static,$(FLAVORS)),$(call install_flavor_extra,$(flavor)))
	dh_install $(addprefix -p,$(LIB_EXTRA_PKGS)) --fail-missing \
		--sourcedir=debian/tmp/extra
	$(call call_and_install_avconv_dump,libavformat55,formats)
	$(call call_and_install_avconv_dump,libavcodec55,codecs)
	$(call call_and_install_avconv_dump,libavcodec-extra-55,codecs)

binary-indep:
	dh_testdir
	dh_testroot
	dh_prep -i
	doxygen doc/Doxyfile
	mkdir -p debian/libav-doc/usr/share/doc/libav-doc
	mv -v doc/doxy/html debian/libav-doc/usr/share/doc/libav-doc
	dh_installdocs -i
	dh_installchangelogs -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i -- -Zxz

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installman -plibav-tools debian/qt-faststart.1
	dh_strip -a --dbg-package=libav-dbg
	dh_lintian -a
	dh_link -a
	dh_compress -a
	dh_fixperms -a

	# operate on non -extra package producing packages
	for pkg in $(LIB_PKGS); do \
	    dh_makeshlibs -p"$$pkg" -V"$$pkg (>= $(SHLIBS_VERSION))"; \
	done
	# operate e.g. the -extra- packages, produce shlibs that have alternative dependencies
	for pkg in $(LIB_EXTRA_PKGS); do \
	    npkg=$$(echo "$$pkg" | sed -r 's/-extra-//'); \
	    dh_makeshlibs -p"$$pkg" -V"$$npkg (>= $(SHLIBS_VERSION)) | $$pkg (>= $(EPOCH)$(UPSTREAM_VERSION))"; \
	done
	# operate on packages with -extra- variants such as libavcodec54 - produce shlibs that have alternative dependencies
	for pkg in $(LIB_PKGS2); do \
	    upkg=$$(echo "$$pkg" | sed -r 's/([0-9]+)$$/-extra-\1/'); \
	    dh_makeshlibs -p"$$pkg" -V"$$pkg (>= $(SHLIBS_VERSION)) | $$upkg (>= $(EPOCH)$(UPSTREAM_VERSION))"; \
	done
	dh_shlibdeps
	dh_installdeb -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a -- -Zxz

binary: binary-indep binary-arch

.PHONY: build $(addprefix build-, $(FLAVORS)) \
	clean \
	$(addprefix configure-, $(FLAVORS)) \
	binary binary-indep binary-arch \
	install install-common install-extra \
	get-orig-source
